///
///\file OLSR_m_rtable.h
///\brief	Header file for multipath routing table
///
#ifndef __OLSR_m_rtable_h__
#define __OLSR_m_rtable_h__
//#include <olsr/OLSR.h>
#include "OLSR_repositories.h"
#include <trace.h>
#include <map>
#include "cmu-trace.h"

///
///\brief defines m_rtable_t as a map of OLSR_m_rt_entry, whose key is the destination address.
///The routing table is thus defined as pairs: [dest address, entry]. 
//typedef std::map<nsaddr_t, OLSR_m_rt_entry*> m_rtable_t;


//typedef std::vector<OLSR_m_rt_entry*> 	m_rtable_t;
typedef std::multimap<nsaddr_t,OLSR_m_rt_entry*> m_rtable_t;


///
///\brief This class is a representation of the OLSR´s multipath routing table
///
class OLSR_m_rtable{
	m_rtable_t m_rt_;
	
	//the flag, to see if the table need to be recomputed.
	bool out_of_date[MAX_NODE];

public:
	OLSR_m_rtable();
	~OLSR_m_rtable();

	m_rtable_t* m_rt();
	void 	set_flag(int id,bool flag);
	void 	set_flag(bool flag);
	bool	get_flag(int id);
	void 	clear();
	void 	rm_entry(nsaddr_t des);
	void	add_entry(OLSR_m_rt_entry* entry,nsaddr_t addr);
	m_rtable_t::iterator 	lookup(nsaddr_t dest);
	
	u_int32_t	size();
	void 	print(Trace*);

};

#endif
